<template>
  <el-form ref="form" :model="form" :rules="rules">
    <template>
      <ele-pro-table
        ref="table"
        :needPage="false"
        :columns="columns"
        :toolkit="[]"
        :datasource="form.datasource"
        cache-key="systemRoleTable17"
        class="time-form"
      >
        <!-- 表头工具栏 -->
        <template v-slot:toolbar>
          <div class="headbox">
            <el-button
              size="small"
              type="primary"
              icon="el-icon-plus"
              class="ele-btn-icon"
              @click="handlAdd"
              v-if="!isContractId"
            >
              新增
            </el-button>
          </div>
        </template>
        <template v-slot:productName="{ row, $index }">
          <el-form-item
            style="margin-bottom: 20px"
            :prop="'datasource.' + $index + '.productName'"
            :rules="{
              required: true,
              message: '请输入',
              trigger: 'change'
            }"
          >
            <el-input
              :disabled="isContractId"
              v-model="row.productName"
              placeholder="请输入"
              @click.native="handParent(row, $index)"
            ></el-input>
          </el-form-item>
        </template>
        <template v-slot:productCode="scope">
          <el-form-item
            style="margin-bottom: 20px"
            :prop="'datasource.' + scope.$index + '.productCode'"
          >
            <el-input v-model="scope.row.productCode" disabled></el-input>
          </el-form-item>
        </template>
        <template v-slot:supplierMark="scope">
          <el-form-item
            style="margin-bottom: 20px"
            :prop="'datasource.' + scope.$index + '.productCode'"
          >
            <el-input v-model="scope.row.supplierMark"></el-input>
          </el-form-item>
        </template>
        <template v-slot:productCategoryName="scope">
          <el-form-item
            style="margin-bottom: 20px"
            :prop="'datasource.' + scope.$index + '.productCategoryName'"
          >
            <el-input
              v-model="scope.row.productCategoryName"
              disabled
            ></el-input>
          </el-form-item>
        </template>
        <template v-slot:totalCount="scope">
          <el-form-item
            style="margin-bottom: 20px"
            :prop="'datasource.' + scope.$index + '.totalCount'"
            :rules="{
              required: true,
              pattern: numberReg,
              message: '请输入数字',
              trigger: 'blur'
            }"
          >
            <el-input
              :disabled="isContractId"
              v-model="scope.row.totalCount"
              placeholder="请输入"
              @input="changeCount(scope.row,scope.$index)"
            ></el-input>
          </el-form-item>
        </template>
        <template v-slot:totalPrice="scope">
          <el-form-item
            style="margin-bottom: 20px"
            :prop="'datasource.' + scope.$index + '.totalPrice'"
          >
            {{
              (scope.row.totalCount * scope.row.singlePrice || 0).toFixed(2)
            }}元
          </el-form-item>
        </template>

        <template v-slot:productBrand="scope">
          <el-form-item
            style="margin-bottom: 20px"
            :prop="'datasource.' + scope.$index + '.productBrand'"
          >
            <el-input v-model="scope.row.productBrand" disabled></el-input>
          </el-form-item>
        </template>

        <template v-slot:modelType="scope">
          <el-form-item
            style="margin-bottom: 20px"
            :prop="'datasource.' + scope.$index + '.modelType'"
          >
            <el-input v-model="scope.row.modelType" disabled></el-input>
          </el-form-item>
        </template>
        <template v-slot:specification="scope">
          <el-form-item
            style="margin-bottom: 20px"
            :prop="'datasource.' + scope.$index + '.specification'"
          >
            <el-input v-model="scope.row.specification" disabled></el-input>
          </el-form-item>
        </template>
        <template v-slot:deliveryDays="scope">
          <el-form-item
            style="margin-bottom: 20px"
            :prop="'datasource.' + scope.$index + '.deliveryDays'"
            :rules="{
              pattern: numberReg,
              message: '请输入数字',
              trigger: 'blur'
            }"
          >
            <el-input
              v-model="scope.row.deliveryDays"
              @change="setDeliveryDays(scope.row, scope.$index, 'deliveryDays')"
              placeholder="请输入"
              :disabled="isContractId"
            ></el-input>
          </el-form-item>
        </template>
        <template v-slot:guaranteePeriod="scope">
          <div class="period">
            <div class="borderleftnone">
              <el-form-item
                style="margin-bottom: 20px"
                :prop="'datasource.' + scope.$index + '.guaranteePeriod'"
                :rules="{
                  pattern: numberReg,
                  message: '请输入数字',
                  trigger: 'blur'
                }"
              >
                <el-input
                  v-model="scope.row.guaranteePeriod"
                  :disabled="isContractId"
                  @change="
                    setDeliveryDays(scope.row, scope.$index, 'guaranteePeriod')
                  "
                  placeholder="请输入"
                ></el-input>
              </el-form-item>
            </div>
            <div class="borderrightnone">
              <DictSelection
                dictName="质保期单位"
                :disabled="isContractId"
                clearable
                v-model="scope.row.guaranteePeriodUnitCode"
                @change="
                  setDeliveryDays(scope.row, scope.$index, 'guaranteePeriod')
                "
              >
              </DictSelection>
            </div>
          </div>
        </template>
        <!-- <template v-slot:guaranteePeriodUnitCode="scope"> </template> -->
        <template v-slot:measuringUnit="scope">
          <el-form-item
            style="margin-bottom: 20px"
            :prop="'datasource.' + scope.$index + '.measuringUnit'"
          >
            <el-input
              :disabled="isContractId"
              v-model="scope.row.measuringUnit"
              placeholder="请输入"
            ></el-input>
          </el-form-item>
        </template>
        <template v-slot:remark="scope">
          <el-form-item
            style="margin-bottom: 20px"
            :prop="'datasource.' + scope.$index + '.remark'"
          >
            <el-input
              :disabled="isContractId"
              v-model="scope.row.remark"
              type="textarea"
              placeholder="请输入"
            ></el-input>
          </el-form-item>
        </template>
        <template v-slot:singlePrice="scope">
          <el-form-item
            style="margin-bottom: 20px"
            :prop="'datasource.' + scope.$index + '.singlePrice'"
            :rules="{
              required: true,
              pattern: numberReg,
              message: '请输入正确的单价',
              trigger: 'change'
            }"
          >
            <el-input
              :disabled="isContractId"
              v-model="scope.row.singlePrice"
              placeholder="请输入"
              @input="getTotalPrice"
            >
              <template slot="append">元</template>
            </el-input>
          </el-form-item>
        </template>
        <template v-slot:technicalAnswerName="{ row, $index }">
          <el-form-item
            style="margin-bottom: 20px"
            :prop="'datasource.' + $index + '.technicalAnswerName'"
          >
            <el-input
              :disabled="isContractId"
              v-model="row.technicalAnswerName"
              placeholder="请输入"
              @click.native="handHead(row, $index)"
            ></el-input>
          </el-form-item>
        </template>
        <template v-slot:technicalParams="scope">
          <el-form-item
            style="margin-bottom: 20px"
            :prop="'datasource.' + scope.$index + '.technicalParams'"
          >
            <el-input
              :disabled="isContractId"
              type="textarea"
              v-model="scope.row.technicalParams"
              placeholder="请输入"
            ></el-input>
          </el-form-item>
        </template>
        <template v-slot:technicalDrawings="scope">
          <el-form-item
            style="margin-bottom: 20px"
            :prop="'datasource.' + scope.$index + '.technicalDrawings'"
          >
            <fileUpload
              :disabled="isContractId"
              v-model="scope.row.technicalDrawings"
              module="main"
              :showLib="false"
              :limit="5"
            />
          </el-form-item>
        </template>
        <template v-slot:guaranteePeriodDeadline="scope">
          <el-form-item
            :prop="'datasource.' + scope.$index + '.guaranteePeriodDeadline'"
          >
            <el-date-picker
              :disabled="isContractId"
              style="width: 140px"
              v-model="scope.row.guaranteePeriodDeadline"
              type="date"
              placeholder="选择日期"
            >
            </el-date-picker>
          </el-form-item>
        </template>
        <template v-slot:deliveryDeadline="scope">
          <el-form-item
            :prop="'datasource.' + scope.$index + '.deliveryDeadline'"
          >
            <el-date-picker
              :disabled="isContractId"
              style="width: 140px"
              v-model="scope.row.deliveryDeadline"
              type="date"
              placeholder="选择日期"
            >
            </el-date-picker>
          </el-form-item>
        </template>
        <template v-slot:headerDeadline="{ column }">
          <span class="is-required">{{ column.label }}</span>
        </template>
        <template v-slot:headerSupplierMark="{ column }">
          <span class="is-required">{{ column.label }}</span>
        </template>
        <template v-slot:headerProductName="{ column }">
          <span class="is-required">{{ column.label }}</span>
        </template>
        <template v-slot:headerTotalCount="{ column }">
          <span class="is-required">{{ column.label }}</span>
        </template>
        <template v-slot:headerSinglePrice="{ column }">
          <span class="is-required">{{ column.label }}</span>
        </template>
        <!-- 操作列 -->
        <template v-slot:action="{ row }">
          <el-popconfirm
            class="ele-action"
            title="确定要删除吗？"
            @confirm="remove(row)"
          >
            <template v-slot:reference>
              <el-link type="danger" :underline="false" icon="el-icon-delete">
                删除
              </el-link>
            </template>
          </el-popconfirm>
        </template>
      </ele-pro-table>
    </template>
    <product-list
      ref="productListRef"
      classType="1"
      @changeParent="changeParent"
    ></product-list>
    <head-list ref="headRef" @changeParent="changeAnswer"></head-list>
  </el-form>
</template>
<script>
import {numberReg} from 'ele-admin';
import productList from '@/views/bpm/handleTask/components/quotation/product-list.vue';
import dictMixins from '@/mixins/dictMixins';
import fileUpload from '@/components/upload/fileUpload';
import headList from '@/components/headList';

const dayjs = require('dayjs');

export default {
  mixins: [dictMixins],
  props: {
    isContractId: {
      type: Boolean,
      default: false
    },
    pricingWay: {
      type: [Number, String],
      default: 1
    }
  },
  components: {
    productList, headList,
    fileUpload
  },

  data() {
    const defaultForm = {
      key: null,
      endTime: '',
      isFirst: 0,
      name: '',
      startTime: '',
      workHour: '',
      technicalDrawings: []
    };
    return {
      discountTotalPrice: 0.0,
      allPrice: 0.0,
      numberReg,
      defaultForm,
      contractStartDate: new Date(),
      form: {
        datasource: []
      },
      rules: {},

      columns: [
        {
          width: 45,
          type: 'index',
          columnKey: 'index',
          align: 'center',
          fixed: 'left'
        },
        {
          width: 200,
          prop: 'productName',
          label: '名称',
          slot: 'productName',
          headerSlot: 'headerProductName',
          align: "center"
        },
        {
          width: 120,
          prop: 'productCode',
          label: '编码',
          slot: 'productCode',
          align: "center"
        },
        {
          width: 200,
          prop: 'productCategoryName',
          label: '类型',
          slot: 'productCategoryName',
          align: "center"
        },
        {
          width: 160,
          prop: 'productBrand',
          label: '牌号',
          slot: 'productBrand',
          align: "center"
        },
        {
          width: 120,
          prop: 'modelType',
          label: '型号',
          slot: 'modelType',
          align: "center"
        },
        {
          width: 120,
          prop: 'supplierMark',
          label: '供应商代号',
          // headerSlot: 'headerSupplierMark',
          slot: 'supplierMark',
          align: "center"
        },
        {
          width: 120,
          prop: 'specification',
          label: '规格',
          slot: 'specification',
          align: "center"
        },

        {
          width: 80,
          prop: 'totalCount',
          label: '数量',
          slot: 'totalCount',
          headerSlot: 'headerTotalCount',
          align: "center"

        },
        {
          width: 80,
          prop: 'measuringUnit',
          label: '计量单位',
          slot: 'measuringUnit',
          align: "center"
        },
        {
          width: 120,
          prop: 'singleWeight',
          label: '单重',
          slot: 'singleWeight',
          align: "center"
        },
        {
          width: 120,
          prop: 'totalWeight',
          label: '总重',
          slot: 'totalWeight',
          align: "center"
        },
        {
          width: 120,
          prop: 'weightUnit',
          label: '重量单位',
          slot: 'weightUnit',
          align: "center"
        },
        {
          width: 160,
          prop: 'singlePrice',
          label: '单价',
          slot: 'singlePrice',
          headerSlot: 'headerSinglePrice',
          align: "center"
        },
        {
          width: 160,
          prop: 'discountSinglePrice',
          label: '折后单价',
          slot: 'discountSinglePrice',
          align: "center",

        },

        {
          width: 120,
          prop: 'totalPrice',
          label: '合计',
          slot: 'totalPrice',
          align: "center"
        },
        {
          width: 120,
          prop: 'discountTotalPrice',
          label: '折后合计',
          slot: 'discountTotalPrice',
          align: "center"
        },
        // {
        //   width: 80,
        //   prop: 'deliveryDays',
        //   label: '交期(天)',
        //   slot: 'deliveryDays'
        // },
        {
          width: 160,
          prop: 'deliveryDeadline',
          label: '交期截止日期',
          slot: 'deliveryDeadline',
          align: "center",
          // headerSlot: 'headerDeadline'
        },
        {
          width: 200,
          prop: 'guaranteePeriod',
          label: '质保期',
          slot: 'guaranteePeriod',
          align: "center"
        },
        {
          width: 160,
          prop: 'guaranteePeriodDeadline',
          label: '	质保截止日期',
          slot: 'guaranteePeriodDeadline',
          align: "center"
        },
        // {
        //   width: 120,
        //   prop: 'guaranteePeriodUnitCode',
        //   label: '',
        //   slot: 'guaranteePeriodUnitCode'
        // },
        {
          width: 130,
          prop: 'technicalAnswerName',
          label: '技术答疑人',
          slot: 'technicalAnswerName',
          align: "center"
        },
        {
          width: 220,
          prop: 'technicalParams',
          label: '技术参数',
          slot: 'technicalParams',
          align: "center"
        },
        {
          width: 240,
          prop: 'technicalDrawings',
          label: '技术图纸',
          slot: 'technicalDrawings',
          align: "center"
        },
        {
          width: 220,
          prop: 'remark',
          label: '备注',
          slot: 'remark',
          align: "center"
        },
        {
          columnKey: 'action',
          label: '操作',
          width: 120,
          align: 'center',
          resizable: false,
          slot: 'action',
          fixed: 'right',
          showOverflowTooltip: true
        }
      ]
    };
  },
  computed: {
    canHandl() {
      return this.form.datasource.length;
    },
    contractId() {
      return this.$store.state.order.contractId;
    }
  },
  methods: {
    // 返回列表数据
    getTableValue() {
      let comitDatasource = this.form.datasource;
      if (comitDatasource.length === 0) return [];
      comitDatasource.forEach((v) => {
        // v.totalPrice = (v.totalCount * v.singlePrice)?.toFixed(2) || 0;
        v.guaranteePeriodUnitName = this.getDictValue(
          '质保期单位',
          v.guaranteePeriodUnitCode
        );
        v.technicalDrawings = Array.isArray(v.technicalDrawings)
          ? v.technicalDrawings
          : [];
      });
      return comitDatasource;
    },
    getPrice() {
      return [this.allPrice];
    },
    //改变数量
    changeCount(row, index) {
      this.singleWeightChange(row, index);
      this.getTotalPrice()
    },
    //计算总金额
    getTotalPrice() {
      if (this.form.datasource.length) {
        let sum = 0;
        sum = this.getNumTotalPrice()
        let allsum = sum.toFixed(2);
        this.allPrice = allsum;
        this.form.discountTotalPrice = allsum;
        this.$store.commit('concact/setDiscountAmount', allsum);
        this.$store.commit('order/setAllcountAmount', allsum);
        this.$emit('orderDiscountAmount', this.allPrice)
        this.$refs.table.reload()
        return allsum;
      } else {
        this.allPrice = 0.0;
        this.form.discountTotalPrice = 0.0;
        this.$emit('orderDiscountAmount', 0)
        return 0.0;
      }
    },
    //计算总金额
    getNumTotalPrice(sum = 0) {
      this.form.datasource.forEach((r) => {
        this.$set(r, 'discountSinglePrice', r.singlePrice ? Number(r.singlePrice) : '')
        if (r.singlePrice && r.totalCount) {
          r.totalPrice = this.getAllPrice(r);
          r.discountTotalPrice = this.getDiscountTotalPrice(r);
          this.$set(r, 'totalPrice', Number(r.totalPrice))
          this.$set(r, 'discountTotalPrice', Number(r.discountTotalPrice))
          sum += Number(r.totalPrice);
        } else {
          this.$set(r, 'totalPrice', '')
          this.$set(r, 'discountTotalPrice', '')
        }
      });
      return sum
    },

    //计算单重
    singleWeightChange(row, index) {
      if (row && row.singleWeight && row.totalCount) {
        row.totalWeight = (row.singleWeight * row.totalCount).toFixed(2) || 0;
        this.$set(this.form.datasource[index], 'totalWeight', row.totalWeight)
      }
      if (this.pricingWay == 2) {
        this.getTotalPrice(row)
      }
    },
    //设置优惠总金额修改产品单价
    discountInputByOrder(val) {
      this.form.discountTotalPrice = val
      //获取优惠金额和总计的差价
      this.form.datasource.forEach((item) => {
        if (val === 0) {
          item.discountTotalPrice = 0
          item.discountSinglePrice = 0
          return
        }
        if (!val) {
          item.discountTotalPrice = item.totalPrice
          item.discountSinglePrice = item.singlePrice
          return
        }
        //获取折让单价
        item.discountSinglePrice = this.getDiscountSinglePrice(item)
        item.discountTotalPrice = this.getDiscountTotalPrice(item)
      })
      this.$refs.table.reload()
      this.$store.commit('concact/setDiscountAmount', val);
    },
    //获取折让单价
    getDiscountSinglePrice(row) {
      let num = Number(this.form.discountTotalPrice) / Number(this.allPrice) * Number(row.singlePrice)
      return isNaN(num) ? '' : num
    },
    //获取合计
    getAllPrice(row) {
      let num = 0
      switch (this.pricingWay) {
        case 1: //按数量计价计算总金额
          num = Number(row.singlePrice) * Number(row.totalCount)
          break;
        case 2 ://按重量计价计算总金额
          num = Number(row.singlePrice) * Number(row.totalCount) * Number(row.singleWeight)
          break;
      }
      return isNaN(num) ? '' : num.toFixed(2)
    },
    //获取折让合计
    getDiscountTotalPrice(row) {
      let num = 0
      switch (this.pricingWay) {
        case 1: //按数量计价计算折让合计
          num = Number(row.discountSinglePrice) * Number(row.totalCount)
          break;
        case 2 ://按重量计价计算折让合计
          num = Number(row.discountSinglePrice) * Number(row.totalCount) * Number(row.singleWeight)
          break;
      }
      return isNaN(num) ? '' : num.toFixed(2)
    },
    //修改回显
    putTableValue(data, contractStartDate) {
      if (contractStartDate) {
        this.contractStartDate = contractStartDate;
      }
      if (data) {
        data.forEach((item) => {
          item.guaranteePeriodUnitCode = item.guaranteePeriodUnitCode + '';

          // if (item.deliveryDays) {
          //   item['deliveryDeadline'] = this.setDay(item.deliveryDays);
          // }
        });
        this.form.datasource = data;
      }
    },
    //选择产品
    handParent(row, index) {
      let item = {
        id: row.productCode
      };
      this.$refs.productListRef.open(item, index);
    },
    //选择技术人回调
    changeAnswer(obj, idx) {
      this.$set(this.form.datasource[idx], 'technicalAnswerId', obj.id);
      this.$set(this.form.datasource[idx], 'technicalAnswerName', obj.name);
    },
    handHead(row, index) {
      let item = {
        id: row.technicalAnswerId
      };
      this.$refs.headRef.open(item, index);
    },
    //选择产品回调
    changeParent(obj, idx) {
      this.$set(this.form.datasource[idx], 'categoryName', obj.name);
      this.$set(
        this.form.datasource[idx],
        'productCategoryId',
        obj.categoryLevelId
      );
      this.$set(this.form.datasource[idx], 'productBrand', obj.brandNum);
      this.$set(
        this.form.datasource[idx],
        'productCategoryName',
        obj.categoryLevelPath
      );
      this.$set(this.form.datasource[idx], 'productCode', obj.code);
      this.$set(this.form.datasource[idx], 'productName', obj.name);
      this.$set(this.form.datasource[idx], 'modelType', obj.modelType);
      this.$set(
        this.form.datasource[idx],
        'measuringUnit',
        obj.measuringUnit
      );
      this.$set(
        this.form.datasource[idx],
        'specification',
        obj.specification
      );
    },
    remove(row) {
      let index = this.form.datasource.findIndex((n) => n.key == row.key);
      if (index !== -1) {
        this.form.datasource.splice(index, 1);
        this.setSort();
      }
    },
    // 清空表格
    restTable() {
      this.form.datasource = [];
    },
    // 重新排序
    setSort() {
      this.form.datasource.forEach((n, index) => {
        n.key = index + 1;
      });
    },
    // 添加
    handlAdd() {
      let item = JSON.parse(JSON.stringify(this.defaultForm));
      item.key = this.form.datasource.length + 1;
      this.form.datasource.push(item);
    },
    setDeliveryDays(row, index, type) {
      if (type == 'deliveryDays') {
        this.$set(
          this.form.datasource[index],
          'deliveryDeadline',
          this.setDay(row.deliveryDays)
        );
      }
      if (type == 'guaranteePeriod') {
        let guaranteePeriodUnitName = this.guaranteePeriodUnit(
          row.guaranteePeriodUnitCode
        );
        this.$set(
          this.form.datasource[index],
          'guaranteePeriodDeadline',
          guaranteePeriodUnitName != 'second'
            ? this.setDay(row.guaranteePeriod, guaranteePeriodUnitName)
            : ''
        );
      }
    },
    guaranteePeriodUnit(code) {
      return code == 3
        ? 'day'
        : code == 4
          ? 'month'
          : code == 5
            ? 'year'
            : 'second';
    },
    setDay(addDay, dateType = 'day') {
      return dayjs(this.contractStartDate || new Date())
        .add(addDay, dateType)
        .format('YYYY-MM-DD');
    },

    validateForm(callback) {
      //开始表单校验
      this.$refs.form.validate((valid) => {
        callback(valid);
      });
    }
  }
};
</script>
<style lang="scss" scoped>
.headbox {
  display: flex;
  justify-content: space-between;
  align-items: center;

  .amount {
    font-size: 14px;
    font-weight: bold;
    padding-right: 30px;
  }
}

.time-form .el-form-item {
  margin-bottom: 0 !important;
}

::v-deep .period {
  display: flex;

  .borderleftnone {
    .el-input--medium .el-input__inner {
      border-top-right-radius: 0;
      border-bottom-right-radius: 0;
    }
  }

  .borderrightnone {
    .el-input--medium .el-input__inner {
      border-top-left-radius: 0;
      border-bottom-left-radius: 0;
    }
  }
}

::v-deep .time-form tbody > tr:hover > td {
  background-color: transparent !important;
}

::v-deep .time-form .el-table tr {
  background-color: #ffffff;
}

.pricebox {
  display: flex;
  justify-content: flex-start;
  align-items: center;
  font-weight: bold;
}
</style>
